=== memory/documentation/Makefile ===
# Makefile for documentation creation

pdf:
	doxygen Doxyfile.pdf
	cd latex; make
