=== webgl/tests/Makefile ===
all: tests

tests:
	./wgl-test.sh
