=== paxage/debian/control ===
Package: @@{CONF:product}
Version: @@{CONF:version}.@@{CONF:build}
Section: non-free/web
Priority: optional
Architecture: @@{TRADITIONAL_ARCH}
Depends: @@{FILES:shlibdeps}, gstreamer0.10-plugins-good, debconf (>= 0.5) | debconf-2.0, fonts-liberation | ttf-liberation | ttf-mscorefonts-installer
Recommends: flashplugin-nonfree, cups-client
Provides: www-browser, mail-reader, imap-client, news-reader
Installed-Size: @@{FILES:installedsize}
Maintainer: @@{S_MAINTAINER}
Bugs: @@{S_BUGREPORT_URL}
Homepage: @@{S_HOMEPAGE}
Description: @@{S_ONELINE_DESC}
 @@include ../doc/description.inc
